/*	$Id: types.h 1728 2005-05-06 08:08:53Z jgressma $
 *
 *  Copyright 2005 University of Potsdam, Germany
 * 
 *	This file is part of Platypus.
 *
 *  Platypus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Platypus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Platypus; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef BUILTIN_TYPES_REGISTRATION_H
#define BUILTIN_TYPES_REGISTRATION_H

#include <platypus/types_fwd.h>
#include <platypus/factories/registration.h>


namespace Platypus
{
    namespace Nomore {
        class Program;
        class Expander;
    }
    
    class BuiltinTypesRegistrar
	{
		Registrar<class SmodelsExpander> smodelsExpander;
		Registrar<class SmodelsEnhancedProgram> smodelsProgram;
        
        Registrar<Nomore::Program> nomoreProgram;
        Registrar<Nomore::Expander> nomoreExpander;

		Registrar<class Local> local;
		Registrar<class SingleThreadedCore> stCore;
		Registrar<class MultiThreadedCore> mtCore;
		Registrar<class DelegatableChoicePolicy::Largest> dcPolicyLargest;
		Registrar<class DelegatableChoicePolicy::Random> dcPolicyRandom;
		Registrar<class DelegatableChoicePolicy::Smallest> dcPolicySmallest;
		Registrar<class ProbingPolicy::Null> probingPolicyNull;
		Registrar<class ProbingPolicy::Largest> probingPolicyLargest;
		Registrar<class ChoicePolicy::RandomTrue> choicePolicyRandomTrue;
		Registrar<class ChoicePolicy::RandomFalse> choicePolicyRandomFalse;
		Registrar<class ChoicePolicy::RandomRandom> choicePolicyRandomRandom;
	
	};
}

#endif

